import Vue from 'vue';
import App from './App';
import methods from './methods';
import config from './config';

Vue.config.productionTip = false;

// 全局混入
import mixins from 'mixins/index.js';
Vue.use(mixins);

App.mpType = 'app';

// 附加方法到 Vue 原型上
for (let key in methods) {
  Vue.prototype[key] = methods[key];
}

for (let key in config) {
  Vue.prototype[key] = config[key];
}

import store from './store';
Vue.prototype.$store = store;

// 倒计时触发器
setInterval(() => {
  uni.$emit('timer');
}, 1000);

const app = new Vue({
  ...App,
  store,
});
app.$mount();
