import date from 'date-php';

let filters = {
  dateYmd(time) {
    return date('Y-m-d', new Date(time));
  },
  dateYmdHis(time) {
    return date('Y-m-d H:i:s', new Date(time));
  },
};

export default {
  install(Vue) {
    Vue.mixin({
      data() {
        return {
          pageParams: {},
          userInfo: {},
        };
      },

      onLoad(options) {
        this.pageParams = options;
        this.userInfo = uni.getStorageSync('userInfo') || {};
      },

      filters,
    });
  },
};
