export default {
  data() {
    return {
      cfmOpts: {
        show: false,
        content: '',
        type: '',
        index: '',
        item: {},
      },
    };
  },

  methods: {
    showConfirm(item, index, message, type) {
      this.cfmOpts.content = message;
      this.cfmOpts.item = item;
      this.cfmOpts.index = index;
      this.cfmOpts.type = type;
      this.cfmOpts.show = true;
    },

    onConfirm() {
      if (this.cfmOpts.type == 'cancel') this.cancelOrder();
      if (this.cfmOpts.type == 'finished') this.finishedOrder();
    },

    // 取消订单接口
    cancelOrder() {
      uni.showLoading({
        title: '操作中'
      })
      this.wjRequest('/order/cancel', 'get', {
        id: this.cfmOpts.item.id
      }, res => {
        uni.hideLoading()
        uni.showToast({
          title: res.message,
          icon: 'none'
        });
        if (res.success) {
          if (this.cfmOpts.index == -1) this.order.status = 'cancel';
          else this.dataList[this.cfmOpts.index].status = 'cancel';
          this.$forceUpdate();
        }
      });
    },

    finishedOrder() {
      this.wjRequest('/order/finished', 'get', {
        id: this.cfmOpts.item.id
      }, res => {
        uni.showToast({
          title: res.message,
          icon: 'none'
        });
        if (res.success) {
          if (this.cfmOpts.index == -1) this.order.status = 'finished';
          else this.dataList[this.cfmOpts.index].status = 'finished';
          this.$forceUpdate();
        }
      });
    },
  },
};
