import verify from '@/common/js/verify.js';

export default {
  data() {
    return {
      userLocation: {},
      formData: {
        name: '',
        mobile: '',
        province: '',
        provinceCode: '',
        city: '',
        cityCode: '',
        district: '',
        districtCode: '',
        address: '',
        longitude: '',
        latitude: '',
        default: 0,
      },
    };
  },
  onLoad() {
    this.userLocation = uni.getStorageSync('userLocation') || {};
    if (this.isEmpty(this.userLocation)) {
      this.getLocation(res => {
        this.userLocation = res;
      });
    }
    if (this.pageParams.id) {
      this.getAddressOne();
    }
  },
  methods: {
    useThis() {
      this.formData.province = this.userLocation.address_component.province;
      this.formData.provinceCode = this.userLocation.address_component.provinceCode;
      this.formData.city = this.userLocation.address_component.city;
      this.formData.cityCode = this.userLocation.address_component.cityCode;
      this.formData.district = this.userLocation.address_component.district;
      this.formData.districtCode = this.userLocation.address_component.districtCode;
      this.formData.address = this.userLocation.address_component.street;
      this.formData.longitude = this.userLocation.longitude;
      this.formData.latitude = this.userLocation.latitude;
    },

    chooseLocation() {
      uni.chooseLocation({
        success: resL => {
          this.reverseGeocoder({ latitude: resL.latitude, longitude: resL.longitude }, res => {
            this.formData.province = res.address_component.province;
            this.formData.provinceCode = res.address_component.provinceCode;
            this.formData.city = res.address_component.city;
            this.formData.cityCode = res.address_component.cityCode;
            this.formData.district = res.address_component.district;
            this.formData.districtCode = res.address_component.districtCode;

            let address = resL.address;
            address = address.replace(res.address_component.province, '');
            address = address.replace(res.address_component.city, '');
            address = address.replace(res.address_component.district, '');
            this.formData.address = address;

            this.formData.longitude = res.longitude;
            this.formData.latitude = res.latitude;
          });
        },
      });
    },

    switchChange(e) {
      console.log(e);
      this.formData.default = e.detail.value ? 1 : 0;
    },

    getAddressOne() {
      this.wjRequest('/address/single', 'get', { id: this.pageParams.id }, res => {
        this.formData = res.data;
      });
    },

    checkForm() {
      var verifyCon = [
        ['n', 'isEmpty', this.formData.name, '请输入姓名'],
        ['n', 'CheckMoble', this.formData.mobile, '手机号格式不正确'],
        ['n', 'isEmpty', this.formData.province, '请选择地址'],
      ];

      var verifyRes = verify(verifyCon, true);
      if (verifyRes) {
        uni.showToast({
          title: verifyRes[3],
          icon: 'none',
        });
        return false;
      }
      this.submitForm();
    },

    submitForm() {
      this.wjRequest(this.pageParams.id ? '/address/edit' : '/address/add', 'post', this.formData, res => {
        uni.showToast({ title: res.message, icon: 'none' });
        if (res.message) {
          setTimeout(() => {
            this.wjRouterGo(1);
          }, 1500);
        }
      });
    },
  },
};
