export default {
  data() {
    return {
      dataList: [],
      isLoading: false,
      allCheck: false,
      price: 0,
      checkNumber: 0,
      checkIds: [],
      randomPost: [],
      deloptions: [{ text: '删除', style: { backgroundColor: '#f96c2f' } }],
      needAuth: false,
    };
  },

  onShow() {
    this.userInfo = uni.getStorageSync('userInfo') || {};
    this.needAuth = this.isEmpty(this.userInfo);
    this.isLoading = true;
    this.checkIds = [];
    this.getCart(data => {
      if (data) {
        // 默认全选
        data.map(item => {
          item.check = true;
        });

        this.dataList = data;
        this.$store.commit('updateCartNum', data.length);

        if (data.length) uni.setTabBarBadge({ index: 2, text: String(data.length) });
        else uni.removeTabBarBadge({ index: 2 });

        this.calePrice();
        this.isLoading = false;
      } else {
        uni.removeTabBarBadge({ index: 2 });
      }
    });
  },

  onLoad() {
    this.getRandomPost();
  },

  methods: {
    delClick(gindex, e) {
      this.wjRequest('/cart/delete', 'get', { goods_id: this.dataList[gindex].goods_id }, res => {
        uni.showToast({ title: res.message, icon: 'none' });
        if (res.success) {
          this.dataList.splice(gindex, 1);
          this.calePrice();
        }
      });
    },

    checkGItem(gitem, gindex) {
      this.dataList[gindex].check = !gitem.check;
      this.calePrice();
      this.$forceUpdate();
    },

    calePrice() {
      this.price = 0;
      this.checkIds = [];
      this.checkNumber = 0;
      for (let i = 0; i < this.dataList.length; i++) {
        if (this.dataList[i].check) {
          this.checkNumber++;
          this.price += this.dataList[i].sku.goods_price * this.dataList[i].buy_number;
          this.checkIds.push(this.dataList[i].id);
        }
      }
      if (this.dataList.length == this.checkNumber) this.allCheck = true;
      else this.allCheck = false;
      uni.setStorageSync('checkIds', this.checkIds);
    },

    allCheckClick() {
      this.allCheck = !this.allCheck;
      this.dataList.map(item => {
        item.check = this.allCheck;
      });
      this.calePrice();
    },

    changeBuyNumber(e, gitem, gindex) {
      let needUpdate = false;
      if (e == -1) {
        if (gitem.buy_number > 1) {
          this.dataList[gindex].buy_number--;
          // this.dataList[gindex].sku.goods_stock++;
          needUpdate = true;
        }
      } else {
        if (gitem.buy_number < gitem.sku.goods_stock) {
          this.dataList[gindex].buy_number++;
          // this.dataList[gindex].sku.goods_stock--;
          needUpdate = true;
        }
      }

      needUpdate &&
        this.updateNumber(gitem.goods_id, gitem.buy_number, res => {
          uni.showToast({ title: res.message, icon: 'none' });
          if (res.success) this.calePrice();
          else this.dataList[gindex].buy_number -= e;
        });
    },

    updateNumber(goods_id, buy_number, cb) {
      this.wjRequest('/cart/updateNumber', 'post', { goods_id, buy_number }, res => {
        cb(res);
      });
    },

    getRandomPost() {
      this.wjRequest('/randomPost', 'get', { number: 6, type: 'goods' }, res => {
        this.randomPost = res.data;
      });
    },

    logged(userInfo) {
      this.userInfo = userInfo;
      this.needAuth = false;
    },

    toCheckOrder() {
      if (this.isEmpty(this.checkIds)) {
        uni.showToast({ title: '请选择商品', icon: 'none' });
        return;
      }
      this.wjRouterPush('checkOrder');
    },
  },
};
