export default {
  data() {
    return {
      dataList: [],
      page: 0,
      rows: 20,
      isLoading: false,
      noMore: false,
      svHeight: 0,

      catArray: [{ category_name: '全部', id: 0 }],
      catIndex: 0,
      catSubArray: [{ category_name: '全部', id: 0 }],
      catSubIndex: 0,
      category_id: 0,

      isFirstLoad: true,
      needWatchSub: true,
    };
  },

  onShow() {
    this.getCart(data => {
      if (data) {
        this.$store.commit('updateCartNum', data.length);
        if (data.length) uni.setTabBarBadge({ index: 2, text: String(data.length) });
        else uni.removeTabBarBadge({ index: 2 });
      } else {
        uni.removeTabBarBadge({ index: 2 });
      }
    });

    if (!this.isFirstLoad) {
      this.getIndexCat();
      if (this.category_id) {
        this.calcIndexCat();
        this.initGet();
      }
    }
  },

  onLoad() {
    let wInfo = uni.getSystemInfoSync();
    this.svHeight = wInfo.windowHeight - (wInfo.windowWidth / 750) * 180 - 3;

    this.getIndexCat();
    this.getCategory(() => {
      this.getData();
    });

    setTimeout(() => {
      this.isFirstLoad = false;
    }, 1000);
  },

  watch: {
    catSubIndex() {
      if (!this.needWatchSub) {
        this.needWatchSub = true;
        return;
      }

      this.initGet();
    },
  },

  methods: {
    getIndexCat() {
      let category_id = uni.getStorageSync('category_id');
      if (category_id) {
        this.category_id = category_id;
        uni.removeStorageSync('category_id');
      } else {
        this.category_id = 0;
      }
    },

    calcIndexCat() {
      for (let i = 0; i < this.catArray.length; i++) {
        if (this.catArray[i].id == this.category_id) {
          this.catIndex = i;
          this.calcSubCat();
          break;
        }
        if ('children' in this.catArray[i]) {
          for (let j = 0; j < this.catArray[i].children.length; j++) {
            if (this.catArray[i].children[j].id == this.category_id) {
              this.catIndex = i;
              this.calcSubCat();
              this.needWatchSub = false;
              this.catSubIndex = j + 1;
              break;
            }
          }
        }
      }
    },

    getCategory(cb) {
      this.wjRequest('/category', 'get', { type: 'goods' }, res => {
        this.catArray = [{ category_name: '全部', id: 0 }, ...res.data];
        this.calcIndexCat();
        cb();
      });
    },

    calcSubCat() {
      this.catSubIndex = 0;
      if ('children' in this.catArray[this.catIndex]) {
        this.catSubArray = [{ category_name: '全部', id: 0 }, ...this.catArray[this.catIndex].children];
      } else {
        this.catSubArray = [{ category_name: '全部', id: 0 }];
      }
    },

    catClick(cindex) {
      this.catIndex = cindex;
      this.calcSubCat();
      this.initGet();
    },

    getData() {
      if (this.isLoading) return;
      if (this.noMore) return;
      this.page++;
      // 分类
      let tem_cat_id = this.catArray[this.catIndex].id;
      tem_cat_id = tem_cat_id == 0 ? undefined : tem_cat_id;
      let tem_cat_id2 = this.catSubArray[this.catSubIndex].id;
      tem_cat_id2 = tem_cat_id2 == 0 ? undefined : tem_cat_id2;
      this.wjRequest('/post', 'get', { type: 'goods', category: tem_cat_id2 || tem_cat_id, page: this.page, rows: this.rows }, res => {
        if (res.data.length < this.rows) this.noMore = true;
        this.dataList = res.data;
      });
    },

    initGet() {
      this.page = 0;
      this.noMore = false;
      this.dataList = [];
      this.getData();
    },
  },
};
