export default {
  data() {
    return {
      payType: 0,
      order: {},
    };
  },

  onLoad() {
    this.getOrder();
  },

  methods: {
    getOrder() {
      this.wjRequest('/order/single', 'get', { id: this.pageParams.order_id }, res => {
        this.order = res.data;
      });
    },

    getPayParams() {
      // #ifdef MP-WEIXIN
      const url = '/wxspPay/getPayParams';
      // #endif

      // #ifdef MP-BAIDU
      const url = '/baiduPay/getPayParams';
      // #endif

      // #ifdef APP-PLUS
      const url = '/alipay/getPayParams';
      // #endif

      return new Promise(r => {
        this.wjRequest(url, 'get', { order_id: this.pageParams.order_id }, res => {
          if (res.success) {
            r(res.data);
          } else {
            uni.showToast({ title: res.message, icon: 'none' });
          }
        });
      });
    },

    async startPay() {
      const params = await this.getPayParams();
      const jumpParams = {
        path: 'payResult',
        query: { type: 'success', order_no: this.pageParams.order_no, order_id: this.pageParams.order_id },
      };

      // 开始支付
      uni.requestPayment({
        provider: 'wxpay',
        // #ifdef MP-WEIXIN
        ...params,
        // #endif
        // #ifdef MP-BAIDU
        orderInfo: params,
        // #endif
        success: () => {
          jumpParams.query.type = 'success';
          this.wjRouterReplace(jumpParams);
        },
        fail: err => {
          console.log(err);
          jumpParams.query.type = 'error';
          this.wjRouterPush(jumpParams);
        },
      });
    },
  },
};
