export default {
  data() {
    return {
      svHeight: 0,
      rows: 10,
      page: 0,
      isLoading: false,
      noMore: false,
      dataList: [],
    };
  },

  onLoad() {
    let wInfo = uni.getSystemInfoSync();
    this.svHeight = wInfo.windowHeight - 1;
    this.getComment();
  },

  methods: {
    getComment() {
      if (this.isLoading) return;
      if (this.noMore) return;
      this.isLoading = true;
      this.page++;
      uni.showLoading({
        title: '加载中',
        mask: true
      });
      this.wjRequest(
        '/comment',
        'get', {
          page: this.page,
          rows: this.rows,
          post_type: 'goods',
          post_id: this.pageParams.post_id,
          user_id: this.pageParams.user_id
        },
        res => {
          this.isLoading = false;
          uni.hideLoading();
          if (this.page == 1) this.dataList = res.data;
          else this.dataList.push(...res.data);
          if (res.data.length < this.rows) this.noMore = true;
        }
      );
    },
  },
};
