export default {
  data() {
    return {
      order: {},
    };
  },

  onLoad() {
    this.getOrder();
  },

  methods: {
    getOrder() {
      this.wjRequest('/order/single', 'get', { id: this.pageParams.id }, res => {
        for (let i = 0; i < res.data.goods.length; i++) {
          res.data.goods[i].comment_content = '';
          res.data.goods[i].comment_score = 5;
          res.data.goods[i].comment_images = [];
        }
        this.order = res.data;
      });
    },

    upload(e) {
      this.formData.images = e.join();
    },

    submitComment() {
      let formData = this.order.goods.map(item => {
        return {
          order_id: this.order.id,
          goods_id: item.goods_id,
          comment_content: item.comment_content,
          comment_score: item.comment_score,
          comment_images: item.comment_images,
        };
      });

      for (let i = 0; i < formData.length; i++) {
        if (this.isEmpty(formData[i].comment_content)) {
          uni.showToast({ title: `请输入第${i + 1}个商品评论内容`, icon: 'none' });
          return;
        }
      }

      this.wjRequest('/comment/add', 'post', { formData }, res => {
        uni.showToast({ title: res.message, icon: 'none' });
        if (res.success) {
          setTimeout(() => {
            this.wjRouterGo(1);
          }, 1500);
        }
      });
    },

    starClick(gitem, gindex, sindex) {
      this.order.goods[gindex].comment_score = sindex + 1;
      this.$forceUpdate();
    },

    upload(gindex, e) {
      this.order.goods[gindex].comment_images = e;
      this.$forceUpdate();
    },
  },
};
