export default {
  data() {
    return {
      dataList: [],
      page: 0,
      rows: 20,
      isLoading: false,
      noMore: false,

      catArray: [],
      banner: [],
    };
  },

  onLoad() {
    this.getCategory();
    this.getData();
    this.getBanner();
  },

  onShow() {
    this.getCart(data => {
      if (data) {
        this.$store.commit('updateCartNum', data.length);
        if (data.length) uni.setTabBarBadge({ index: 2, text: String(data.length) });
        else uni.removeTabBarBadge({ index: 2 });
      } else {
        uni.removeTabBarBadge({ index: 2 });
      }
    });
  },

  methods: {
    getBanner() {
      this.wjRequest('/ads/slug?slug=homeBanner', 'get', {}, res => {
        this.banner = res.data;
      });
    },

    getCategory() {
      this.wjRequest('/category', 'get', { type: 'goods', recommend: 1 }, res => {
        this.catArray = res.data;
      });
    },

    // 推荐商品
    getData() {
      if (this.isLoading) return;
      if (this.noMore) return;
      this.page++;
      this.wjRequest('/post', 'get', { type: 'goods', recommend: 1, page: this.page, rows: this.rows }, res => {
        if (res.data.length < this.rows) this.noMore = true;
        this.dataList = res.data;
      });
    },

    toCategory(hitem) {
      uni.setStorageSync('category_id', hitem.id);
      this.wjRouterSwitchTab('category');
    },

    toBanner(bitem) {
      if (this.isEmpty(bitem.id)) return;
      switch (bitem.type) {
        case 'post':
          this.wjRouterPush({ path: 'single', query: { id: bitem.id } });
          break;
        case 'page':
          this.wjRouterPush({ path: 'page', query: { id: bitem.id } });
          break;
        case 'goods':
          this.wjRouterPush({ path: 'goodsSingle', query: { id: bitem.id } });
          break;
        case 'goodsCategory':
          uni.setStorageSync('category_id', bitem.id);
          this.wjRouterSwitchTab('category');
          break;
        case 'docs':
          this.wjRouterPush({ path: 'single', query: { id: bitem.id } });
          break;
        default:
          console.log('banner to default');
      }
    },
  },

  onReachBottom() {
    this.getData();
  },
};
