export default {
  data() {
    return {};
  },
  onLoad() {},
  methods: {
    uploadAvatar() {
      uni.chooseImage({
        sizeType: ['compressed'],
        success: res => {
          uni.uploadFile({
            url: this.APIURL + '/upload',
            filePath: res.tempFilePaths[0],
            name: 'upfile',
            success: res2 => {
              let data = JSON.parse(res2.data);
              this.userInfo.avatar = data.data;
            },
            fail: err => {
              console.log(err);
            },
          });
        },
      });
    },

    submitForm() {
      if (this.isEmpty(this.userInfo.avatar)) {
        uni.showToast({ title: '请上传头像', icon: 'none' });
        return;
      }

      if (this.isEmpty(this.userInfo.display_name)) {
        uni.showToast({ title: '请输入昵称', icon: 'none' });
        return;
      }

      this.wjRequest('/user/profile', 'post', { avatar: this.userInfo.avatar, display_name: this.userInfo.display_name }, res => {
        uni.showToast({ title: res.message, icon: 'none' });
        if (res.success) {
          setTimeout(() => {
            this.getUser();
            this.wjRouterGo(1);
          }, 1500);
        }
      });
    },
  },
};
