export default {
  data() {
    return {
      dataList: [],
      page: 0,
      rows: 20,
      isLoading: false,
      noMore: false,
      svHeight: 0,
      isFocus: false,
      keyword: '',
      keywordList: [],
      autoFocus: true,
    };
  },

  onLoad() {
    let wInfo = uni.getSystemInfoSync();
    this.svHeight = wInfo.windowHeight - (wInfo.windowWidth / 750) * 100 - 1;
    this.keywordList = uni.getStorageSync('keywordList') || [];
    // this.getData();
  },

  methods: {
    getData() {
      if (this.isLoading) return;
      if (this.noMore) return;
      this.page++;
      this.wjRequest('/post', 'get', { type: 'goods', page: this.page, rows: this.rows, keyword: this.keyword }, res => {
        if (res.data.length < this.rows) this.noMore = true;
        this.dataList = res.data;
      });
    },

    initPage() {
      this.page = 0;
      this.dataList = [];
      this.noMore = false;
      this.getData();

      // 加入本地搜索关键词
      if (!this.isEmpty(this.keyword)) {
        let index = this.in_array(this.keyword, this.keywordList);
        if (index) this.keywordList.splice(index - 1, 1);
        this.keywordList.splice(0, 0, this.keyword);
        uni.setStorageSync('keywordList', this.keywordList);
      }

      this.isFocus = false;
    },

    keywordClick(kitem) {
      this.keyword = kitem;
      this.initPage();
    },
  },
};
